/*
 128Gamma.C - Main 128Gamma Source File
*/
//					128Gamma - Data Encryption Project

#include <Windows.H>
#include <WindowsX.H>
#include <io.h>
#include <Stdio.H>
#include <Stdlib.H>
#include <string.h>
#include <ctype.h>
#include <ShellAPI.H>

#include "Headers/Definitions.H"

#include "Headers/Registry.H"	 // Registry Def & Functions

#include "Headers/Functions.H"

#include "Headers/PackFiles.H"
#include "Headers/UnpackFiles.H"

#include "Dialogs/Password.H"
#include "Dialogs/About.H"
#include "Dialogs/Status.H"

#include "Headers/128Coding.H"
#include "Headers/IncodeBuffer.H"
#include "Headers/DecodeBuffer.H"

#include "Headers/Processes.H"	 // Crypting Processes Functions
#include "Headers/Compression.H" // Compression Functions

////////////////////////////////////////////////////////////////////////

extern int WINAPI WinMain(HWND hInst, HWND hPrev, LPSTR Cmd, int nCmdShow)
{
	if(OpenMutex(SYNCHRONIZE, FALSE, "128Gamma Priority"))
	{
		MessageBox (NULL, "You Cannot Run 128Gamma While You Are Changing The Priority." , TitleCaption, 0 + MB_ICONASTERISK + MB_SYSTEMMODAL);
		return 0;
	}

	if(OpenMutex(SYNCHRONIZE, FALSE, TitleCaption))
	{
		MessageBox (NULL, "Only One Instance Of 128Gamma Can Run At A Time!" , TitleCaption, 0 + MB_ICONASTERISK + MB_SYSTEMMODAL);
		return 0;
	}
	CreateMutex(0,0, TitleCaption);

	hInstance = hInst;

	if(SetTempVariables())
		Error("Error Setting Temporary Files. Error 1.");

	if(strcmp(Cmd,"128GammaSignature") == 0)
	{
		char xSignature[30];
		sprintf(xSignature,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",65,117,116,104,101,110,116,105,99,32,49,50,56,71,97,109,109,97,32,83,105,103,110,97,116,117,114,101);
		MessageBox(0, xSignature ,GammaVersion, 0 + MB_TASKMODAL);
		return 0;
	}

	DWORD Registration = 0;
	if(GetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","Registered",Registration))
	{
		if(Registration == 1)
		{
			Registration = 0;
			if(GetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","128Code",Registration))
			{
				if(Registration == RegCode)Registration = 1;
				else Registration = 0;
			}
			else Registration = 0;
		}
		else Registration = 0;
	}
	else Registration = 0;

	if(Registration == 1) // If 128Gamma Is Registered
	{
		Registered = TRUE;
		ShortVersion = Reg_ShortVersion;
		MaxFiles = Reg_MaxFiles;
		MaxPackFileSize = Reg_MaxPackFileSize;
		MaxFileSize = Reg_MaxFileSize;
	}
	else{ // If 128Gamma Is NOT Registered
		Registered = FALSE;
		if(MessageBox(GetActiveWindow(),"This Is An Unregisterd Version Of 128Gamma.\r\n This message does not apear on registered versions. \r\n\r\n Would you like to buy the full version now?",TitleCaption,4+256+MB_ICONQUESTION + MB_SYSTEMMODAL) == IDYES)
		{
			ShellExecute(0,"Open","Http://128Gamma.NetWorkDLS.Com",NULL,NULL,SW_SHOWNORMAL);
			return 0;
		}
		ShortVersion = Unreg_ShortVersion;
		MaxFiles = Unreg_MaxFiles;
		MaxPackFileSize = Unreg_MaxPackFileSize;
		MaxFileSize = Unreg_MaxFileSize;
	}

	if(ProcessInput(Cmd)) // If No (Or Invalad) Input Diaplay About Box
	{
		DialogBox(hInstance,MAKEINTRESOURCE(1000),PasswordDialog_hWnd,AboutDialog);
	}
	return 0;
}

////////////////////////////////////////////////////////////////////////

