/*

 Definitions.H - Main 128Gamma Variable Definition File

*/

//--------------------------------------------------------------------

#if defined(__cplusplus)
#error 128Gamma was designed to be compiled using C not C++.
#endif

#define TitleCaption "128Gamma Encryption"
#define GammaVersion "Version 2.5  - Revision C"

#define FlagLEN 12			 // Length Of Encrypt/Pack Flags

#define PACCompress "CompressPack"
#define ENCCompress "CompressFile"

#define PACFlag "128GammaPack"
#define ENCFlag "128GammaFile"

#define VersionInfo 10000 // VersionInfo SystemMenu wParam Identifier

#define BufferSize 512	  // Size Of Buffer Used For Copy Processes
#define MegaByte 1048576  // One Megabyte (1,048,576 Bytes)
#define RegCode 29856748  /* Number Written To Registry By Register.Exe
							 To Valadate Registration */

#define Reg_ShortVersion "2.5 C"
#define Reg_MaxFiles 750000
#define Reg_MaxPackFileSize MegaByte * 100
#define Reg_MaxFileSize MegaByte * 1000

#define Unreg_ShortVersion "UNREGISTERED"
#define Unreg_MaxFiles 10
#define Unreg_MaxPackFileSize MegaByte * 1
#define Unreg_MaxFileSize MegaByte * 5

//--------------------------------------------------------------------
		/* Thread Handles, ID's And Prototypes*/ // Begin

// --------

extern DWORD WINAPI EncryptProcess_Thread(LPVOID);
HANDLE EncryptProcess_Thread_Handle;
long EncryptProcess_Thread_ID;

extern DWORD WINAPI DecryptProcess_Thread(LPVOID);
HANDLE DecryptProcess_Thread_Handle;
long DecryptProcess_Thread_ID;

extern DWORD WINAPI PackProcess_Thread(LPVOID);
HANDLE PackProcess_Thread_Handle;
long PackProcess_Thread_ID;

extern DWORD WINAPI UnpackProcess_Thread(LPVOID);
HANDLE UnpackProcess_Thread_Handle;
long UnpackProcess_Thread_ID;

// --------

extern DWORD WINAPI CompressEncryptProcess_Thread(LPVOID);
HANDLE CompressEncryptProcess_Thread_Handle;
long CompressEncryptProcess_Thread_ID;

extern DWORD WINAPI DecompressDecryptProcess_Thread(LPVOID);
HANDLE DecompressDecryptProcess_Thread_Handle;
long DecompressDecryptProcess_Thread_ID;

extern DWORD WINAPI CompressPackProcess_Thread(LPVOID);
HANDLE CompressPackProcess_Thread_Handle;
long CompressPackProcess_Thread_ID;

extern DWORD WINAPI DecompressUnpackProcess_Thread(LPVOID);
HANDLE DecompressUnpackProcess_Thread_Handle;
long DecompressUnpackProcess_Thread_ID;

// --------

extern DWORD WINAPI StatusDialog_Thread(LPVOID );
HANDLE StatusDialog_Thread_Handle;
long StatusDialog_Thread_ID;

		/* Thread Handles, ID's And Prototypes*/ // End
//--------------------------------------------------------------------
		/* Various Function Prototypes */ // Begin

extern void SetText (HWND, char *);
extern void CenterWindow (HWND);
extern void Error(char *);
extern void ClearBuffer(void);
extern void Update_LastUsed(void);
extern void FreeMemory(void);
extern void Clear_ReadTemp(void);

extern char *GetText (HWND);
extern char *GetTempDirectory(void);
extern char *CipherKey(char []);
extern char *Get_Time (void);
extern char *Get_LongDate (void);
extern char *Get_UserName (void);

extern int WINAPI WinMain(HWND , HWND , LPSTR , int );
extern int PasswordDialog (HWND, int , int , int );
extern int AboutDialog (HWND, int , int , int );
extern int StatusDialog (HWND , int , int , int );
extern int PackFiles(char *,char *);
extern int UnPackFiles(char *,char *);

extern int IncodeBuffer(char *, char *, char *);
extern int DecodeBuffer(char *, char *, char *);

extern int IncodeMain(char *, char *);
extern int DecodeMain(char *, char *);

extern int Compress(char *, char *);
extern int Decompress(char *, char *);

extern int EncryptProcess(void);
extern int DecryptProcess(void);
extern int PackProcess(void);
extern int UnpackProcess(void);
extern int CompressEncryptProcess(void);
extern int DecompressDecryptProcess(void);
extern int CompressPackProcess(void);
extern int DecompressUnpackProcess(void);

extern int ProcessInput(char *);
extern int CancelProcess(void);

extern int Get_FileNames (char *);
extern int Get_SubFileNames (char *, char *);
extern int PackFolder(char *, char *);
extern int CleanUp(int, int);
extern int PreCheckFile(char *);
extern int SetTempVariables(void);

extern BOOL SetPriority(void);
extern BOOL FAccess(char *, short);
extern DWORD FileSize(char *);

		/* Various Function Prototypes */ // End
//--------------------------------------------------------------------
		/* Various Global Variables */ // Begin

char Buffer[BufferSize];
char EncryptTemp[257];
char CompressTemp[257];
char PackTemp[257];
char GlobalFileName[257];
char Password[75];
char ReadTemp[1024];

struct _Package{
char *FolderNames[Reg_MaxFiles+2];
char *FileNames[Reg_MaxFiles+2];
DWORD FileCount;
DWORD FolderCount;
}; struct _Package Package;

char *Status;
char *CodedKey;
char *ShortVersion;

DWORD MaxFiles = 0;
DWORD MaxPackFileSize = 0;
DWORD MaxFileSize = 0;

long double StatusValue = 0;

		/* Various Global Variables */ // End
//--------------------------------------------------------------------
		/* Various Windows Handles */ // Begin

static HWND hInstance = 0;
static HWND PasswordDialog_hWnd = 0;
static HWND AboutDialog_hWnd = 0;
static HWND StatusDialog_hWnd = 0;

static HWND StatusText_hWnd = 0;
static HWND StatusBar_hWnd = 0;

		/* Various Windows Handles */ // End
//--------------------------------------------------------------------
		/* Global Variables Used As Flags (BOOL) */ // Begin

BOOL CompressEncrypt = FALSE;
BOOL DecompressDecrypt = FALSE;
BOOL CompressPack = FALSE;
BOOL DecompressUnpack = FALSE;

BOOL Encrypt = FALSE;
BOOL Decrypt = FALSE;
BOOL Pack = FALSE;
BOOL Unpack = FALSE;

BOOL Registered = FALSE;
BOOL CancelFlag = FALSE;
BOOL Verifiy = FALSE;
BOOL DoneFlag = FALSE;
BOOL KillFlag = FALSE;

		/* Global Variables Used As Flags */ // End
//--------------------------------------------------------------------


