/*
 Functions.H - Main 128Gamma Functions File

*/

//--------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////

extern void Error(char *Message)
{
	KillFlag = 1;
	CleanUp(1,1);
	MessageBox(GetActiveWindow(), Message ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL + MB_TASKMODAL);
}

//////////////////////////////////////////////////////////////////////

extern int CleanUp(int Kill, int Delete)
{
	if(Delete)
	{
		_fcloseall(); //Attempt To Close All Open Files... (If Any)
		unlink(CompressTemp);
		unlink(EncryptTemp);
		unlink(PackTemp);
	}

	if(Kill)
	{
		_fcloseall(); //Attempt To Close All Open Files... (If Any)
		sleep(500); // Hopfully Give Time For Files To Reset Or Flush.
		unlink(CompressTemp);
		unlink(EncryptTemp);
		unlink(PackTemp);
		exit(0);
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////

extern int PreCheckFile(char *FileToCheck)
{
	FILE * FileToCheck_File;
	unsigned int Attrib = 0;

	/* Get Input File Attributes */
	Attrib = GetFileAttributes(GlobalFileName);

	/* If ReadOnly... Prompt User */
	if(Attrib & FILE_ATTRIBUTE_READONLY)
	{
		if(MessageBox(GetActiveWindow(),"This File Is ReadOnly.\r\nSet To Normal Access? ",TitleCaption,4+256+MB_ICONQUESTION + MB_SYSTEMMODAL) != 6)
			return 0;
		SetFileAttributes(FileToCheck,FILE_ATTRIBUTE_NORMAL);
	}

	/* Check For File Access */
	if(!FAccess(FileToCheck,0)) // Check Exist
		Error("File Does Not Exist. Error 14.");
	if(!FAccess(FileToCheck,2)) // Check Write Access
		Error("File Does Not Allow Write Access. Error 15.");
	if(!FAccess(FileToCheck,4)) // Check Read Access
		Error("File Does Not Allow Read Access. Error 16.");
	if(!FAccess(FileToCheck,6)) // Check Read & Write Access
		Error("File Does Not Allow Read And Write Access. Error 17.");

	if(Attrib & FILE_ATTRIBUTE_DIRECTORY) // If Input Is A Folder
	{
		/* If Directory Name Is 3 Char Long  ( c:\ d:\ ...Etc ) */
		if(strlen(FileToCheck) == 3)
		{
			char MessageTemp[257];
			sprintf(MessageTemp,"128Gamma %s Does Not Have Support For Full Drives At This Time.",ShortVersion);
			MessageBox(GetActiveWindow(),MessageTemp,TitleCaption,+ MB_SYSTEMMODAL);
			return 0;
		}
		return 1;
	}

	DWORD FileSize_Temp = FileSize(FileToCheck);
	if(FileSize_Temp == -1)return 0;

	if(FileSize_Temp > MaxFileSize)
	{
		char MessageTemp[257];
		sprintf(MessageTemp,"128Gamma %s Requires That Files Be Under %d MB",ShortVersion,MaxFileSize/1024/1024);
		MessageBox(GetActiveWindow(),MessageTemp,TitleCaption,+ MB_SYSTEMMODAL);
		return 0;
	}

	if(FileSize_Temp < 1)
	{
		char MessageTemp[257];
		sprintf(MessageTemp,"128Gamma %s Requires That Files Contain Some Data.",ShortVersion);
		MessageBox(GetActiveWindow(),MessageTemp,TitleCaption,+ MB_SYSTEMMODAL);
		return 0;
	}

	/* Open Source File */
	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL)
		Error("Could Not Open Source For Read. Error: 18.");

	/* Read File Flag ( If Any ) */
	fread(Buffer,sizeof(char),FlagLEN,FileToCheck_File);

	if(strcmp(Buffer,ENCFlag) == 0) // If File Encryted
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 2;
	}

	if(strcmp(Buffer,PACFlag) == 0) // If File Packed
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 3;
	}

	if(strcmp(Buffer,ENCCompress) == 0) // If File Compressed Encryted
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 4;
	}

	if(strcmp(Buffer,PACCompress) == 0) // If File Compressed Packed
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 5;
	}

	if(FileToCheck_File)
		fclose(FileToCheck_File);
	return 6; // If File Not Encrypted
}

//////////////////////////////////////////////////////////////////////

extern int SetTempVariables(void)
{
	sprintf(EncryptTemp,"%s\\%s",GetTempDirectory(),"Encrypt.128G");
	sprintf(PackTemp,"%s\\%s",GetTempDirectory(),"Pack.128G");
	sprintf(CompressTemp,"%s\\%s",GetTempDirectory(),"Compress.128G");

	if(!CompressTemp)
		return 1;
	if(!EncryptTemp)
		return 1;
	if(!PackTemp)
		return 1;

	return 0;
}

//////////////////////////////////////////////////////////////////////

extern char *GetTempDirectory(void)
{
	static char StrFunction [64][257] = {'\0'};
	int StrCnt = 0;
	char T[257] = {'\0'};
	GetTempPath (256,T);
	if (++StrCnt==64) StrCnt = 0;
	sprintf(StrFunction[StrCnt],"%s",T);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

extern void SetText (HWND hDlg, char *Txt)
{
	SendMessage(hDlg,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)Txt);
}

/////////////////////////////////////////////////////////////////////

extern char *GetText (HWND hDlg)
{
	int StrCnt = 0;
	int T = 0;
	char xBuffer[2048] = {'\0'};
	LPSTR StrFunc[16] = {'\0'};
	if (++StrCnt==16) StrCnt = 0;
	if (StrFunc[StrCnt]) free (StrFunc[StrCnt]);
	StrFunc[StrCnt] = (char*) malloc (2048);
	memset (StrFunc[StrCnt],0,2048);
	T=GetWindowTextLength(hDlg);
	GetWindowText(hDlg,xBuffer,T+1);
	sprintf(StrFunc[StrCnt],"%s",xBuffer);
	return StrFunc[StrCnt];
}
/////////////////////////////////////////////////////////////////////

extern void CenterWindow (HWND hWnd)
{
	static RECT wRect;
	DWORD x = 0;
	DWORD y = 0;
	GetWindowRect(hWnd,&wRect);
	x=(GetSystemMetrics(SM_CXSCREEN)-(wRect.right-wRect.left))/2;
	y=(GetSystemMetrics(SM_CYSCREEN)-(wRect.bottom-wRect.top+GetSystemMetrics(SM_CYCAPTION)))/2;
	SetWindowPos(hWnd,NULL,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
}

/////////////////////////////////////////////////////////////////////

extern int ProcessInput(char *xInput)
{
	short ENCMethod = 0;

	if(strlen(xInput) > 0) // If Any Program Input Params
	{
		sprintf(GlobalFileName,"%s",xInput);

		/*
		0 = Cancel , Dir = 1 , Encrypted = 2 , Packed = 3
		Compressed Encrypted = 4 , Compressed Packed = 5
		Not Encrypted = 6
		*/

		ENCMethod = PreCheckFile(GlobalFileName);

		if(ENCMethod == 0) // Cancel
			return 0;

		if(ENCMethod == 1) // Directory
		{
			Pack = TRUE; // Encrypt File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 2) // Encrypted
		{
			Decrypt = TRUE; // Decrypt File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 3) //  Packed
		{
			Unpack = TRUE; // Unpack File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 4) //  Compressed Encrypted
		{
			DecompressDecrypt = TRUE; // Decompress Decrypt File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 5) //  Compressed Packed
		{
			DecompressUnpack = TRUE; // Decompress Unpack File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 6) // NOT Encrypted
		{
			Encrypt = TRUE; // Encrypt File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}
	}

	CleanUp(0,1);

	return 1;
}

/////////////////////////////////////////////////////////////////////

extern DWORD FileSize(char *File2Size)
{
	FILE *Source;
	DWORD size;
	SetFileAttributes(File2Size,FILE_ATTRIBUTE_NORMAL);
	Source = CreateFile(File2Size,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
	size = GetFileSize(Source,NULL);
	if(size == HFILE_ERROR)
	{
		char StatusTemp[1024];
		sprintf(StatusTemp,"128Gamma %s Cannot Read: \r\n%s \r\nThe File May Be In Use.",ShortVersion,File2Size);
		MessageBox(StatusDialog_hWnd, StatusTemp ,TitleCaption,0 + MB_SYSTEMMODAL);
		return -1;
	}
	CloseHandle(Source);
	return size;
}

///////////////////////////////////////////////////////////////////////

extern void ClearBuffer(void)
{
	int LocalLoop;
	LocalLoop = 0;
	while(LocalLoop < sizeof(Buffer))
	{
		Buffer[LocalLoop] = '\0';
		LocalLoop++;
	}
}

///////////////////////////////////////////////////////////////////////

extern DWORD WINAPI StatusDialog_Thread(LPVOID data)
{
	DialogBox(hInstance,MAKEINTRESOURCE(200),0,StatusDialog);
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI EncryptProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);
	EncryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI DecryptProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);
	DecryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI PackProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);
	PackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI UnpackProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);
	UnpackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI CompressEncryptProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);
	CompressEncryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI DecompressDecryptProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);
	DecompressDecryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI CompressPackProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);
	CompressPackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern DWORD WINAPI DecompressUnpackProcess_Thread(LPVOID data)
{
	/* Set 128Gamma Priority */
	if( SetPriority() ) return((DWORD)data);
	DecompressUnpackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

extern char *Get_Time()
{
	static SYSTEMTIME st;			   //SystemTime
	static char t [257];			   //SystemTime (Time)
	GetLocalTime(&st);
	GetTimeFormat(LOCALE_USER_DEFAULT,TIME_NOSECONDS,&st,NULL,t,64);
	return (t);
}

//////////////////////////////////////////////////////////////////////

extern char *Get_LongDate ()
{
	static SYSTEMTIME st;			   //SystemTime
	static char d [257];			   //SystemTime (LONG Date)
	GetLocalTime(&st);
	GetDateFormat(LOCALE_USER_DEFAULT,DATE_LONGDATE,&st,NULL,d,64);
	return (d);
}

//////////////////////////////////////////////////////////////////////

extern char *Get_UserName ()
{
	static char StrFunction [64][257];
	static int StrCnt;
	static char A[257];
	static DWORD b;
	if (++StrCnt==64) StrCnt = 0;
	b=256;
	GetUserName(A,&b);
	sprintf(StrFunction[StrCnt],"%s",A);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

/*
6	Check for read and write permission
4	Check for read permission
2	Check for write permission
1	Execute (ignored)
0	Check for existence of file
*/

extern BOOL FAccess(char *FileName, short Mode)
{
	if(access(FileName, Mode) == 0)
		return 1;
	return 0;
}

//////////////////////////////////////////////////////////////////////

extern void Update_LastUsed(void)
{
	SetStringValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\LastRun","User",Get_UserName());
	SetStringValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\LastRun","Date",Get_LongDate());
	SetStringValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\LastRun","Time",Get_Time());
}

//////////////////////////////////////////////////////////////////////

extern void FreeMemory(void)
{
	while(Package.FolderCount != 0)
	{
		free(Package.FolderNames[Package.FolderCount]);
		Package.FolderNames[Package.FolderCount] = '\0';
		Package.FolderCount--;
	}
	while(Package.FileCount != 0)
	{
		free(Package.FileNames[Package.FileCount]);
		Package.FileNames[Package.FileCount] = '\0';
		Package.FileCount--;
	}
}

///////////////////////////////////////////////////////////////////////

extern void Clear_ReadTemp(void)
{
	int LocalLoop = 0;
	while(LocalLoop < sizeof(ReadTemp))
	{
		ReadTemp[LocalLoop] = '\0';
		LocalLoop++;
	}
}

//////////////////////////////////////////////////////////////////////

extern BOOL SetPriority(void)
{
	DWORD Priority = 0;
	BOOL HighOrRealTime = FALSE;
	HANDLE CurrentProcessHandle = GetCurrentProcess();
	HANDLE CurrentThreadHandle = GetCurrentThread();

	if(GetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","Process",Priority))
	{
		if(Priority == 1)SetPriorityClass(CurrentProcessHandle,IDLE_PRIORITY_CLASS);
		if(Priority == 2)SetPriorityClass(CurrentProcessHandle,NORMAL_PRIORITY_CLASS);
		if(Priority == 3)SetPriorityClass(CurrentProcessHandle,HIGH_PRIORITY_CLASS);
		if(Priority == 4)SetPriorityClass(CurrentProcessHandle,REALTIME_PRIORITY_CLASS);
		if(Priority > 2)HighOrRealTime = TRUE;
	}
	else SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","Process",2);

	Priority = 0;

	if(GetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","Thread",Priority))
	{
		if(Priority == 1)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_IDLE);
		if(Priority == 2)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_LOWEST);
		if(Priority == 3)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_BELOW_NORMAL);
		if(Priority == 4)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_NORMAL);
		if(Priority == 5)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_ABOVE_NORMAL);
		if(Priority == 6)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_HIGHEST);
		if(Priority == 7)SetThreadPriority(CurrentThreadHandle,THREAD_PRIORITY_TIME_CRITICAL);
		if(Priority > 5)HighOrRealTime = TRUE;
	}
	else SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","Thread",4);

	if(HighOrRealTime == TRUE)
	{
		if(MessageBox(StatusDialog_hWnd,"128Gamma Is Running In High, RealTime Or TimeCritical Mode. \r\nThis Severly Cripples Windows Performance. \r\nContinue Anyway? ",TitleCaption,4+256+MB_ICONQUESTION + MB_SYSTEMMODAL) != 6)
		{
			CancelFlag = TRUE;
			DoneFlag = 1;
			return TRUE;
		}
	}

	Priority = 0;

	if(GetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","ThreadBoost",Priority))
	{
		if(Priority == 0)SetThreadPriorityBoost(CurrentThreadHandle,TRUE); //Disable Boost
		if(Priority == 1)SetThreadPriorityBoost(CurrentThreadHandle,FALSE); //Enable Boost
	}
	else SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","ThreadBoost",1);

	Priority = 0;

	if(GetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","ProcessBoost",Priority))
	{
		if(Priority == 0)SetProcessPriorityBoost(CurrentProcessHandle,TRUE); //Disable Boost
		if(Priority == 1)SetProcessPriorityBoost(CurrentProcessHandle,FALSE); //Enable Boost
	}
	else SetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Priority","ProcessBoost",1);

	return FALSE; // No Error... Return False
}

//////////////////////////////////////////////////////////////////////

